# coding=UTF-8 

import re
import os
import sys
config_path = '/etc/cpu-taskset.conf/cpu-taskset.ini'
#config_path = 'cpu-taskset.ini'
if not os.path.exists(config_path):
    processor_to_cpu_part = {}
    with open('/proc/cpuinfo', 'r') as file:
        for line in file:
            if line.startswith('processor'):
                processor = int(line.split(':')[1].strip())
                while True:
                    next_line = next(file, None)
                    if next_line is None or 'CPU part' in next_line:
                        break
                if 'CPU part' in next_line:
                    match = re.search(r'CPU part\s*:\s*0x([0-9a-fA-F]+)', next_line)
                    if match:
                        cpu_part = int(match.group(1), 16)
                        processor_to_cpu_part[processor] = cpu_part

    all_same = len(set(processor_to_cpu_part.values())) == 1
    max_processors = []
    if all_same:
        print('All CPU parts are the same: False')
    else:
        max_cpu_part = max(processor_to_cpu_part.values())
        max_processors = [processor for processor, cpu_part in processor_to_cpu_part.items() if cpu_part == max_cpu_part]
        print("The processors with the maximum CPU part value are:")
        for proc in max_processors:
            print("processor {}".format(proc))
    with open(config_path, 'w') as file:
        if all_same:
            file.write('[cpubind]\nbind=0\n')
            file.write('[maxprocessor]\nprocessor-list=-1\n')
        else:
            file.write('[cpubind]\nbind=1\n')
            processor_list_str = ','.join(map(str, max_processors))
            print('xxxxxxx={}'.format(processor_list_str))
            file.write('[maxprocessor]\n')
            file.write('processor-list={}\n'.format(processor_list_str))
        file.write('[bindapp]\napplist=/usr/bin/ukui-control-center,/usr/bin/peony\n')
    # for processor, cpu_part in processor_to_cpu_part.items():
    #     print('processor {}: CPU part {}'.format(processor, cpu_part))
else:
    sys.exit()


